var name = 'fk2';
const os = require('os');
const fs = require('fs');
const arg = process.argv;
var cpu = os.cpus().length;
const path = require('path');
const cluster = require('cluster');
const logs = require('../plug-in/colorLog');
if (arg[2] == 'start') {
    // fk2 start ...
    if(!arg[3]){
        logs.r('The script can not be empty');
        logs.r('fk2 start demo.js <i>');
        logs.close();
        return
    }else{
        var paths = path.join(process.cwd(), arg[3]);
        if (!fs.existsSync(paths)) {
            if (fs.existsSync(paths + '.js')) {
                paths = paths + '.js';
            } else if (fs.existsSync(paths + '.ts')) {
                paths = paths + '.ts';
            } else {
                logs.r('Can not find ' + arg[3] + ' script!');
                logs.r('error path: ' + paths);
                logs.close();
                return
            }
        }
        if (!arg[4]&&arg[4]!==0){
            cpu = 1;
        }else if(arg[4]>0&&arg[4]<os.cpus().length+1){
            cpu = arg[4];
        }else{
            logs.r("This arg '" + arg[4] + "' is error!");
            logs.close();
            return
        }
        name = arg[3];
    }
}else{
    // json验证集群秘钥是否合法
    const check = require('./checkSecretKey');
    console.log(check());
}
const { pid, ppath } = require('../plug-in/fk2Path');
if (cluster.isMaster || cluster.isPrimary) {
    /* 多少个cpu启动多少个子进程 */
    const data = fs.readdirSync(pid);
    const wk = require('./worker');// 封装wk循环
    const { check } = require('../plug-in/psNode');
    logs.g('Service is starting , please later ...');
    logs.close();
    checkFile();
    async function checkFile() {
        fs.writeFileSync(ppath(process.pid), JSON.stringify({
            name,
            code:2,
            comd:arg[2],
            cwd:process.cwd()
        }));
        for (let i = 0; i < cpu; i++) {
            wk(cluster.fork());
            if (i == cpu - 1) {
                logs.g('Open fk2 clusters!');
                logs.close();
            }
        }
        if (data.length > 0) {
            // 存在进程文件
            for (const key in data) {
                // 检查进程是否存在
                const res = await check(data[key]);
                if (res == 0) {
                    fs.unlinkSync(ppath(data[key])); //删掉已退出进程文件
                }
            }
        }
    }
    /* 如果有线程退出了，我们重启一个 */
    cluster.on('exit', (obj) => {
        const data = JSON.parse(fs.readFileSync(ppath(obj.process.pid)));
        if (data.code > 0) {
            fs.unlinkSync(ppath(obj.process.pid)); //删掉退出进程文件
            wk(cluster.fork());
        }
    })
} else {
    if (arg[2] == 'start'){
        new require(paths);
    }else{
        new require('./go');
    }
    /* 心跳回应 */
    const file = ppath(process.pid);
    fs.writeFileSync(file, JSON.stringify({
        name,
        code:1,
        comd:arg[2],
        cwd:process.cwd()
    }));
    fs.watchFile(file, (cur, prv) => {
        // 监听文件
        if (cur.mtime !== prv.mtime) {
            const data = JSON.parse(fs.readFileSync(file));
            if (data.code == 3) process.exit(0);
        }
    })
    process.on('message', (msg) => {
        msg === 'ping' && process.send('pong');
    })
}

